﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace fontgrid
{
    public partial class Form1 : Form
    {
        private const int MIN_WIDTH = 5;
        private const int MAX_WIDTH = 60;
        private const int MIN_HEIGHT = 8;
        private const int MAX_HEIGHT = 150;

        private int fontWidth = 8;
        private int fontHeight = 16;



        public Form1()
        {
            InitializeComponent();
        }

        private void ButtonGenerate_Click(object sender, EventArgs e)
        {
            int n;
            String s;

            s = textBoxWidth.Text;
            if (int.TryParse(s, out n))
            {
                if (n < MIN_WIDTH) n = MIN_WIDTH;
                else if (n > MAX_WIDTH) n = MAX_WIDTH;
                fontWidth = n;
            }
            else
            {
                fontWidth = MIN_WIDTH;
            }
            textBoxWidth.Text = fontWidth.ToString();

            s = textBoxHeight.Text;
            if (int.TryParse(s, out n))
            {
                if (n < MIN_HEIGHT) n = MIN_HEIGHT;
                else if (n > MAX_HEIGHT) n = MAX_HEIGHT;
                fontHeight = n;
            }
            else
            {
                fontHeight = MIN_HEIGHT;
            }
            textBoxHeight.Text = fontHeight.ToString();

            draw_grid();
        }

        private void ButtonSave_Click(object sender, EventArgs e)
        {
            if(saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String s = saveFileDialog1.FileName;
                pictureBox1.Image.Save(s);


            }
        }

        private void draw_grid()
        {
            int areaWidth = (fontWidth + 1) * 16 + 1;
            int areaHeight = (fontHeight + 1) * 8 + 1;




            pictureBox1.Width = areaWidth;
            pictureBox1.Height = areaHeight;

            //Bitmap bmp = new Bitmap(pictureBox1.Size.Width, pictureBox1.Size.Height);
           
            Bitmap bmp = new Bitmap(areaWidth, areaHeight);
            pictureBox1.Image = bmp;

            Graphics g = Graphics.FromImage(pictureBox1.Image);

            //Graphics g = pictureBox1.CreateGraphics();
            g.FillRectangle(Brushes.White, 0, 0, areaWidth, areaHeight);
            int i,j,n;

            n = 0x20;
            String s;
            Font fnt = new Font("ＭＳ ゴシック", fontHeight * 6 / 10);

            for (i = 2; i < 8; i++)
            {
                for (j = 0; j < 16; j++)
                {
                    s = "";
                    s += (char)n;
                    g.DrawString(s, fnt, Brushes.LightGray, j * (fontWidth + 1), i * (fontHeight + 1) + 1);
                    n++;
                }
            }




            n = 0;
            for(i=0;i<17; i++)
            {
                g.DrawLine(Pens.Blue, n, 0, n, areaHeight);
                n += fontWidth + 1;
            }

            n = 0;
            for (i = 0; i < 9; i++)
            {
                g.DrawLine(Pens.Blue, 0, n, areaWidth,n);
                n += fontHeight + 1;
            }



            //リソースを解放する
            fnt.Dispose();
            g.Dispose();

            pictureBox1.Refresh();


        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBoxWidth.Text = fontWidth.ToString();
            textBoxHeight.Text = fontHeight.ToString();





        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            draw_grid();
        }

        private void PictureBox1_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
